2005-03-02  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-mode-map): bind C-c C-s to new comman
	sgml-show-structure.
	Update autoloads.

	* psgml-edit.el (sgml-show-structure): new command
	(sgml-show-structure-insert, sgml-show-struct-element-p)
	(sgml-structure-elements): new functions

2005-02-27  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-content-indent-function): moved
	(sgml-attribute-indent-function): moved

	* psgml-edit.el (sgml-show-context): use new option
	sgml-show-context-function.
	(sgml-show-context-standard, sgml-show-context-backslash): new
	functions for sgml-show-context-function
	(sgml-right-menu): new command for use on a mouse button

	* psgml.el (sgml-mode-map): bind C-c C-t to
	sgml-show-current-element-type
	(sgml-show-context-function): new option

	* psgml-edit.el (sgml-show-current-element-type): new command

	* psgml.el (sgml-mode-map): change C-c C-p to sgml-load-doctype

	* psgml-parse.el (sgml-load-doctype): make interactive, this is a
	more useful command than sgml-parse-prolog.

	* psgml-info.el (sgml-describe-dtd): rename sgml-general-dtd-info
	to sgml-describe-dtd. Keep old name as alias.

	* psgml-other.el (sgml-set-face-for): added face setting for content

	* psgml-parse.el (sgml--pi-element-handler): use sgml-parse-s not
	sgml-skip-ps.

2005-02-24  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-do-processing-instruction): call
	sgml--pi-psgml-handler with end point of PI.
	(sgml--pi-psgml-handler): Take end point, and narrow buffer before
	parsing.

2005-02-17  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-parse-prolog): apply sgml-general-case to
	sgml-default-doctype-name.


2005-02-09  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-debug): remove sgml-log-message
	remove log related keybinding/menu entry

	* psgml-parse.el (sgml-compile-dtd, sgml-check-entities)
	(sgml-log-warning, sgml-error): remove sgml-log-message
	(sgml-entity-stack): new func

	* psgml-ids.el: New file (From: Jean-Daniel.Fekete)
	* psgml-edit.el: ID/IDREF patch (From: Jean-Daniel.Fekete)
	* psgml-maint.el: ID/IDREF patch (From: Jean-Daniel.Fekete)
	* psgml-parse.el: ID/IDREF patch (From: Jean-Daniel.Fekete)

2003-06-09  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-modify-dtd): added some error checking for
	the has-seen-elements.

2003-03-28  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-do-processing-instruction): new handling
	of <?PSGML> processing instruction.
	(sgml--pi-psgml-handler): new func
	(sgml--pi-element-handler): new func. handles <?PSGML ELEMENT ..>
	(sgml-psgml-pi-enable-outside-dtd): new variable. controls when
	<?PSGML> is evaluated.

2003-03-27  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el: fix wrong file name in error trace

2003-03-25  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-dtd.el (sgml-parse-parameter-literal):
	Modified to use unibyte-char-to-multibyte if
	enable-multibyte-characters. I hope this is correct.

2003-03-25  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-dtd.el (sgml-parse-parameter-literal):
	Modified to use unibyte-char-to-multibyte if
	enable-multibyte-characters. I hope this is correct.

2003-02-12  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-setup-doctype): add Predefined Entities
	for XML.

2003-01-24  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-do-move): undo wrong optimization, fix
	problem with non working exclusions.

2002-12-13  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.3.1 released

2002-09-19  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-parse-prolog): Check if sgml-dtd-info is
	nil before trying to use it.

2002-08-13  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-edit-attrib-abort): new command
	(sgml-edit-attrib-mode-map): abort on key C-c C-k
	(sgml-attribute-buffer): include abort key in header line and use
	substitute-command-keys.
	(sgml-edit-attributes): move setting mode to
	sgml-attribute-buffer.

	* psgml-parse.el (sgml-open-element): add optional net-enabled
	parameter.
	(sgml-do-start-tag): use new parameter on sgml-open-element.
	Fixes bug with NET (tc17).

	* psgml-edit.el (sgml-edit-attrib-field-start,
	sgml-edit-attrib-clear, sgml-attribute-buffer,
	sgml-edit-attrib-specification-list): change sgml-category to
	category. Fix bug with edit attributes.
	(sgml-change-element-name): insert TAGC before finding new element
	object. Fix bug with change element name not copying attributes.

2002-05-08  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.3.0 released

	* psgml.el (sgml-default-nonsticky): moved from psgml-other.el

2002-05-07  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-maint.el (psgml-common-files): add psgml-sysdep
	(psgml-find-source-dir): fix version

2002-04-26  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-mode): make adding to
	text-property-default-nonsticky conditional on
	sgml-default-nonsticky to work with Emacs < 21.

2002-04-25  Lennart Staflin  <lenst@lysator.liu.se>

	fixing merge of Dave Love's patch.

2002-02-08  Dave Love  <fx@gnu.org>
	[Merging from 1.2.4 branch /lenst]

	Changes for various things: Useful DTD-less XML editing; avoiding
	CL at runtime; some Emacs portability; Mule-related fixes,
	particularly for non-ASCII names in DTD.

	* psgml-maint.el (psgml-find-source-dir): Fix version number.

	* psgml-info.el (sgml-set-difference, sgml-union): New functions.
	(sgml-eltype-refrenced-elements): Use them and also use
	add-to-list instead of pushnew.

	* psgml-dtd.el: Doc and message fixes.
	(sgml-write-dtd): Use sgml-set-buffer-multibyte and bind
	coding-system-for-write around write-region.
	(sgml-merge-attlists): Use copy-sequence, not copy-list.

	* psgml-edit.el: Require cl when compiling.  Don't set
	byte-compile-warnings.
	(sgml-quote-attribute-value, sgml-tag-regexp)
	(sgml-edit-attrib-next): Use documented way of including `-' in
	regexp range.
	(sgml-change-start-tag, sgml-insert-attribute)
	(sgml-make-attrib-menu, sgml-menu-ask): Fix to work without a DTD.
	(sgml-edit-attrib-next, sgml-tag-regexp): Maybe allow non-ASCII.
	(sgml--all-possible-elements): Kludge for DTD-less case.
	(sgml-make-character-reference): Take care over multibyteness.
	Maybe deal with unicodes.
	(sgml-edit-attrib-specification-list, sgml-edit-attrib-default)
	(sgml-edit-attrib-default, sgml-edit-attrib-clear)
	(sgml-edit-attrib-field-start, sgml-attribute-buffer): Use
	property name `sgml-category', not `category', which is special in
	Emacs. [backed out //lenst]
	(sgml-operate-on-tags): Use sgml-restore-buffer-modified-p.

	* psgml-lucid.el (sgml-insert): Use property name `sgml-category',
	not `category'. [backed out //lenst]

	* psgml.el: Require cl only when compiling.  Doc fixes.
	(sgml-mode): Set text-property-default-nonsticky.  In Emacs, use
	which-fun-mode hook instead of trying to modify mode-line-format.
	<paragraph-separate>: Maybe allow non-ASCII.
	(sgml-mode-map): Define unconditionally. [backed out //lenst]
	(sgml-running-lucid): Defconst, not defvar.
	(sgml-have-re-char-clases): New constant.
	(sgml-markup-faces): Default to font-lock faces if available.
	(sgml-start-tag-regex, sgml-close-angle): Allow non-ASCII if
	possible.
	(sgml-angle-distance, sgml-slash-distance): Defvar, not defconst,
	since it's a user variable.
	(sgml-restore-buffer-modified-p): New alias.
	(sgml-parse-colon-path): Use parse-colon-path, if available.
	[backed out, parse-colon-path is for directories //lenst]
	(sgml-command-post, sgml-mode): Assume make-local-hook exists.

	* psgml-parse.el: Doc and message fixes.
	(sgml-dtd-less): New buffer-local variable.
	(sgml-eltype-name, sgml-eltype-defined, sgml-eltype-token)
	(sgml-token-eltype, sgml-eltype-mixed, sgml-check-name)
	(sgml-element-etag-optional, sgml-element-mixed, sgml-parse-name):
	Avoid unnecessary compiler macros.
	(sgml-read-element-type, sgml-read-element-name): DTRT for non-nil
	sgml-dtd-less.
	(sgml-push-to-entity): Obey sgml-warn-about-undefined-entities.
	Don't make the buffer unibyte here.  Ensure an old one is
	multibyte.
	(sgml-parse-prolog): Set sgml-dtd-less.
	(sgml-attdecl-default-value): Avoid caddr.
	(sgml-entity-marked-undefined-p): Avoid cddddr.  Avoid (CL
	runtime) setter for nthcdr.
	(sgml-load-dtd): Avoid mapcan.
	(sgml-bdtd-load): Set buffer unibyte.
	(sgml-bdtd-merge): Don't set buffer unibyte here.
	(sgml-set-active-dtd-indicator): Set which-func-mode.
	(sgml-merge-eltypes): Use copy-sequence, not copy-list.
	(sgml-open-element-hook, sgml-close-element-hook)
	(sgml-map-eltypes): Remove redundant level of lambda.
	(sgml-entity-case, sgml-general-case): Moved before
	sgml-entity-case use.
	(sgml-update-display): Call force-mode-line-update.
	(sgml-parse-attribute-specification-list): Use sgml-dtd-less.

	* psgml-other.el (sgml-insert): Use plist-get rather than CL
	runtime's getf.
	(sgml-use-text-properties): Default to t.
	(sgml-with-modification-state): New macro.
	(sgml-default-nonsticky): New constant.
	(sgml-set-face-for): Use sgml-with-modification-state,
	sgml-default-nonsticky.
	(sgml-clear-faces): Avoid CL runtime.
	(next-overlay-at): Remove as consequence of above.

	* psgml-fs.el: Require cl and ps-print when compiling.
	(fs-do-style, fs-do-style, fs-do-style): Use plist-get rather than
	CL runtime's getf.
	(fs-element-with-id): Use compare-strings, not equalp.

	* psgml-dtd.el, psgml-charent.el, psgml-api.el, psgml-info.el:
	Require cl when compiling.

	* psgml-debug.el: Require cl, elp and edebug when compiling.


2002-04-19  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.2.5 released

2002-03-17  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-api.el (sgml-map-content): don't try to map empty
	elements, no point and the code doesn't work for that case.

2002-02-13  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-auto-insert-required-elements): doc fix.
	(sgml-balanced-tag-edit): doc fix.

	* psgml-edit.el (sgml-edit-attrib-default): don't make text read-only
	(sgml-insert-tag): doc fix.

2002-02-09  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el: Explicitly setup prefix keys
	(sgml-prefix-f-map): new var
	(sgml-prefix-u-map): new var

2002-02-08  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-set-buffer-multibyte): support setting to
	default
	(sgml-compile-dtd): removed sgml-set-buffer-multibyte, this is
	done by sgml-write-dtd
	(sgml-push-to-entity): reset buffer to default multibyte support

	* psgml-dtd.el (sgml-write-dtd): fixes for multibyte handling

2001-12-20  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-xml-validate-command): new option. Default for
	sgml-validate-command in XML mode.
	(xml-mode): use sgml-xml-validate-command.
	(xml-mode): remove conditional. Always set sgml-declaration to
	sgml-xml-declaration.

2001-12-18  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-attribute-buffer): Don't write-protect the
	"#DEFAULT" marker.
	(sgml-extract-attribute-value): strip any remains of "#DEFAULT".
	(sgml-edit-attrib-next): if point is before the attribute value,
	move to beginning of line to avoid skipping this attribute.

2001-12-16  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.2.4 released

2001-12-16  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-info.el (sgml-eltype-refrenced-elements): use built-in
	function copy-sequence

2001-12-14  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-set-buffer-multibyte): Mule/multibyte patch
	from Yasushi Abe.
	(sgml-compile-dtd): dito.
	(sgml-bdtd-merge): dito.
	(sgml-push-to-entity): dito.
	(sgml-do-entity-ref): fix sgml-warn-about-undefined-entities behviour.

2001-12-06  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-update-display): take max-pos of top-tree
	not current-tree as that is not always defined at that point.

2001-11-09  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.2.3 released

	* psgml.el (sgml-running-lucid): make sure it gets defined during
	compilation.

2001-11-04  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-other.el, psgml-parse.el, psgml-debug.el, psgml-edit.el:
	Fix the obsolete variable `before-change-function' and
	`after-change-function', which are no longer used by Emacs.

2001-02-10  Adrian Aichner  <adrian@xemacs.org>

	* psgml-dtd.el: Fix typos.
	* psgml-edit.el: Ditto.
	* psgml-fs.el: Ditto.
	* psgml-info.el: Ditto.
	* psgml-parse.el: Ditto.
	* psgml.el: Ditto.

Wed Feb 28 00:02:45 2001  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-fs.el (fs-split-tokens): new helper function for use in
	style sheets.

2001-02-28  Lennart Staflin  <lennarts@infostream.no>

	* psgml-other.el (sgml-split-long-menus): new
	(sgml-popup-menu): use above
	(sgml-popup-multi-menu): use above

Wed Feb 21 23:30:07 2001  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-parse-to): remove debug code

2001-02-20  Lennart Staflin  <lennarts@infostream.no>

	* psgml-dtd.el (sgml-check-content): check case of declared
	content name.
	(sgml-parse-exception): fix misspelled function name
	(sgml-declare-entity): Fix wrong case on symbols
	(sgml-parse-entity-type): for consistency, don't downcase entity
	type name
	(sgml-parse-entity-type): Remove case check and intern for
	notation name. Notation name will be stored as a string.

	* psgml-parse.el (sgml-push-to-entity): remove debugging code
	(sgml-set-initial-state): Change to use change hooks

Fri Feb  9 01:06:27 2001  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.2.2 released

	* psgml.el (sgml-mode-map): Bind (meta control h) instead of ESC
	C-h, avoids redefining M-BS

Thu Feb  8 20:08:47 2001  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-info.el: Add provide psgml-info

Sun Oct 22 17:29:53 2000  Marc-Antoine Parent

	* patch from Marc-Antoine Parent

	* psgml-edit.el (sgml-read-attribute-value): include the element name, thus:
	Value for {attribute name} in {element name} ({type} {Default}):


2000-10-11  Lennart Staflin  <lennarts@infotek.no>

	* psgml-edit.el (sgml-indent-line): new strategy for identifying
	elements

2000-09-06  Lennart Staflin  <lennarts@infotek.no>

	* psgml-api.el (sgml-map-content): Use sgml-with-parser-syntax-ro

	* psgml-parse.el (sgml-find-start-point): renamed to
	sgml-goto-start-point, to indicate that this actually changes the
	point and buffer. And should always be called inside
	sgml-with-parser-syntax.
	(sgml-with-parser-syntax-ro): As sgml-with-parser-syntax also
	handle restoring buffer modification state.
	(sgml-last-buffer): New state variable
	(sgml-with-parser-syntax): set sgml-last-buffer
	(sgml-mainbuf-point): new function
	(sgml-max-pos-in-tree): new function
	(sgml-update-display): don't call sgml-find-start-point, use
	sgml-max-pos-in-tree to figure out if there is much to parse.
	(sgml-parse-to): calls sgml-parser-loop directly no
	sgml-parse-continue.
	(sgml-parse-continue): use sgml-with-parser-syntax-ro and
	set-buffer to sgml-last-buffer.

2000-08-24  Lennart Staflin  <lennarts@infotek.no>

	* psgml.el (sgml-insert-defaulted-attributes): new option
	* psgml-edit.el (sgml-insert-attributes): check new option

	* psgml-fs.el (style-format): set ps-left-header to include a
	style-sheet specified title and the filename. (for ps-print-buffer)
	(fs-special-styles): New special style 'title' for setting title.
	(fs-do-style): handle title style
	(fs-element-content): make element argument optional, defaults to
	current element.

2000-08-08  Lennart Staflin  <lennarts@infotek.no>

	* psgml-edit.el (sgml-insert-element): Fix bug with empty element.

Thu Aug  3 07:52:46 2000  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-insert-element): Fix bug when inserting
	element at end of buffer.

2000-08-03  Lennart Staflin  <lennarts@infotek.no>

	* psgml-edit.el (sgml-attribute-buffer): Fix missing space for
	unspecified required attributes.

2000-06-05  Lennart Staflin  <lennarts@infotek.no>

	* psgml-dtd.el (sgml-parse-parameter-literal): use
	buffer-substring-no-properties .

2000-05-31  Lennart Staflin  <lennarts@infotek.no>

	* psgml-api.el (sgml-parse-data): Don't call sgml-parse-loop
	directly, use sgml-parse-continue.

Sat May 27 00:04:31 2000  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-attr-clean-and-insert): new command. Used to
	automatically remove #DEFAULT when a character is typed.
	(sgml-attr-default-keymap): keymap used as only for #DEFAULT in
	attribute editing.

Mon Apr 24 09:55:14 2000  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-complete): Transform case on inserted names
	using sgml-general-insert-case or sgml-entity-insert-case.

Sun Apr 16 16:07:55 2000  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-indent-line): compute indentation from
 	context, not element under point. Did this change once before but
 	had to back it out. This time take care of omitted end-tags by
 	choosing parent element as context, if point is at the very end of
 	the element. Don't do special attribute indenting for elements
 	that occur in data context.
	(sgml-fill-region): Fix giving up to early.
	(sgml-do-fill): indent tags of subelements in element context

	* psgml-info.el (sgml-describe-element-type): Use sgml-princ-names
	for occurs in section.

2000-03-22  Lennart Staflin  <lennarts@infotek.no>

	* psgml-edit.el (sgml-change-element-name): Add end-tag event if
	original element is empty. (hmm this isn't quite right). Also use
	sgml-find-context-of to find element, because -element-of gives
	the element of the following char.

Tue Jan  4 19:51:03 2000  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-with-parser-syntax): Restore current buffer
	before restoring syntax table.

Tue Dec 21 20:50:31 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-other.el (sgml-set-face-for): set rear-nonsticky for face
	when sgml-use-text-properties is true. (Suggested by Dirk Frömbgen)

Sat Dec 18 18:55:02 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-charent.el (sgml-charent-to-display-char): use
	buffer-substring-no-properties to allow for using text properties
	for fontification.

1999-11-02  Tim Bradshaw  <tfb@tfeb.org>

 	* psgml-edit.el (sgml-doctype-insert): made it not loop when it
 	gets a bogus nil

1999-12-16  Lennart Staflin  <lennarts@infotek.no>

	* psgml-parse.el (sgml-parse-prolog): restore buffer modified
	after parsing. To allow using text properties for fontification.
	(sgml-parse-continue): dito.
	(sgml-parse-to): call sgml-parse-continue instead of calling
	sgml-parser-loop directly.

1999-12-15  Lennart Staflin  <lennarts@infotek.no>

	* psgml.el: autoload for sgml-do-set-option

1999-12-03  Lennart Staflin  <lennarts@infotek.no>

	* psgml.el (sgml-mode-syntax-table): new variable
	(sgml-mode): use sgml-mode-syntax-table

1999-11-29  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-validate-error-regexps): Also recognize warnings
	(:W:) in output from nsgmls.

1999-11-11  Lennart Staflin  <lennarts@infotek.no>

	* psgml-parse.el (sgml-parse-to): Let sgml-with-parser-syntax wrap
	a bigger chunk of the code to make sure the syntax table is set up
	before any buffer changes.

Tue Nov  9 16:25:53 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-modify-dtd): use sgml-general-case on names
	from modifier.

Mon Nov  8 22:13:12 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-info.el (sgml-eltype-refrenced-elements): Copy sequence
	before sorting destructively.
	(sgml-describe-element-type): Include exceptions in info display.

Thu Nov  4 19:07:09 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-note-change-at): If in XML mode and
 	previous char is /, back up one char. This allows for the />
 	delimiter to be recognized even if the start tag has been
 	previously parsed as an improperly ended tag.

	* psgml-edit.el (sgml-last-element): don't use sgml-last-element
	for XML (there is not omitted tags to account for).

1999-10-21  Lennart Staflin  <lennarts@infotek.no>

	* psgml-parse.el (sgml-push-to-entity): restore the (erase-buffer)
	that had been commented out. This is needed for the case when
	sgml-try-merge-compiled-dtd fails and leaves junk in the buffer.

1999-10-19  Lennart Staflin  <lennarts@infotek.no>

	* Version 1.2.1 released

1999-10-14  Lennart Staflin  <lennarts@infotek.no>

	* psgml-parse.el (sgml-log-entity-stack): don't use
	sgml-pop-entity, just loop thru the entity stack and print out the
	files.
	(sgml-load-ecat): bind sgml-xml-p while parsing catalog

1999-10-13  Lennart Staflin  <lennarts@infotek.no>

	* psgml-parse.el (sgml-current-file): New variable, holds the name
	of file name (if any) of the entity beeing parsed in the buffer.
	(sgml-parse-warning): New func. Log a parser warning, a warning
	including information about where the error occured. Mostly for
	DTD parsing.
	(sgml-log-entity-stack): new factored function.
	(*) Replaces some sgml-parse-error and sgml-log-warning with
	sgml-parse-warning.
	(sgml-parse-catalog-buffer): bind sgml-xml-p while parsing catalog

Sun Oct 10 15:53:12 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.2 released

Wed Oct  6 00:43:37 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.7 released

	* psgml-parse.el (sgml-push-to-entity): carry XML-ness to parsed
	text entities.

	* psgml-charent.el (sgml-display-char-list-filename): new default
	is "iso8859.map" in the same directory where psgml is installed.

Wed Sep 22 19:34:08 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el: Apply sgml-general-case to attribute name for
 	interactive sgml-insert-attribute. Don't test for non empty asl in
 	sgml-edit-attrib. A lot of changes in handling text attributes
 	when in attribute edit mode.

Sat Aug 14 22:34:59 1999  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-tag-regexp): Recognize XMLs empty tags.

1998-11-16  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-set-local-variable): insert "mode: xml" for
	xml-mode and "mode: sgml" otherwise

	* psgml-edit.el (sgml-add-element-to-element): add end-tag to
	empty xml-elements before inserting an element

1998-11-15  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.6 released

	* psgml-parse.el (sgml-char-int): from XEmacs
	(sgml-read-octet): modified for XEmacs
	(sgml-read-peek): dito.
	(sgml-read-number): dito.

	* psgml.el (sgml-option-value-indicator): moved here.
	(sgml-mode): activate-menubar-hook can't be local in XEmacs and
	sgml-build-custom-menus need to be after the easy-menu-adds.

1998-11-14  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el, psgml-edit.el: Fix from David Megginson to some
	regexps for _: in names.
	(sgml-build-custom-menus): Do not call easy-menu-change with empty
	menu.

	* psgml-edit.el (sgml-do-set-option): Don't modify the *Help*
	buffer directly, call sgml-append-to-help-buffer. Fixes problem
	with read-only buffer.
	(sgml-append-to-help-buffer): new func.

	* psgml.el (sgml-main-menu):  Options handling changed after
	suggestion and code from Matthias Clasen
	(sgml-update-all-options-menus): new func. called by
	activate-menubar-hook

Thu Nov  5 20:59:08 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-parse-processing-instruction): removed let
	of sgml-markup-start. Was probably wrong solution to problem with
	sgml-markup-start beeing nil. Added in-declaration parameter. If
	in a declaration, no fontification should be done.
	(sgml-parse-prolog): do not call sgml-skip-ds, rather call
	parse-s, parse-pi as this is what "other prolog" contains.

1998-10-31  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.5 released

	* psgml-parse.el (sgml-declared-value-notation): change 'notation
	to 'NOTATION

Sat Oct 31 20:00:22 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-cache-catalog): Use file-truename for
	file-attributes, to get modification time from real file and not
	from symlink.

	* psgml.el (xml-mode): Do not build a syntax table
	(sgml-dtd-menu): moved Custom DTD's to submenu
	(sgml-markup-menu): moved Custom Markup to submenu
	(sgml-build-custom-menus): Make submenus for Custom DTD and Markup

	* psgml-parse.el (xml-parser-syntax): build special syntax table
	for XML.
	(sgml-with-parser-syntax): Use sgml-parser-syntax or
	xml-parser-syntax depending on sgml-xml-p

Wed Oct 28 23:15:38 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-read-element-type): use
	let (completion-ignore-case sgml-namecase-general)

Sat Oct 24 13:13:48 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-build-custom-menus): Construct sub-menus for
	custom DTD and custom Markup insert, only if
	easy-menu-filter-return is not defined otherwise use the :filter
	facility to build menu when needed.

	* psgml-edit.el (sgml-what-element): Guard call to
	sgml-deref-shortmap

1998-10-20  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-edit-external-entity): fix from Matthias Clasen

	* psgml.el (sgml-validate-error-regexps): modify regexp to work in
	Emacs 20.3

1998-09-30  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.4 release

Mon Aug 31 21:53:45 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-bdtd-load): Increase version number
	(sgml-read-dtd): Increase version number

	* psgml-dtd.el (sgml-write-dtd): Increase version number

Sat Aug 15 18:58:25 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-complete): add completion of #-reserved words

Fri Jul  3 18:14:21 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.3

	* Makefile.in: Call install with only one source file.

Fri Jul  3 17:54:06 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-complete): ignore case

	* psgml-parse.el (sgml-push-to-entity): use setf to set
	sgml-entity-marked-undefined-p.
	(setf sgml-entity-marked-undefined-p): define setf method

Tue Jun 30 22:06:20 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-do-set-option): Added file-list and
	file-or-nil types contributed by Matthias Clasen
	<mclasen@sun2.mathematik.uni-freiburg.de>

Tue Jun 30 21:48:39 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-mode-map): C-c C-i calls sgml-add-element-to-element

	* psgml-edit.el (sgml-add-element-to-element): New command.

Wed Jun 24 23:23:38 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-attribute-buffer): Fixed another victim of
	the case change.
	(sgml-change-element-name): fix bug with empty XML element

Mon Jun 22 19:58:43 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (psgml-version): Version 1.1.2

	* Installed patch from Matthias Clasen
	<clasen@pong.mathematik.uni-freiburg.de>.
	Adding notation to entities and a sgml-notation-handlers variable
	used by sgml-edit-external-entity.

	* psgml-edit.el (sgml-indent-line): Previous change of
	sgml-indent-line did not work well with OMITTAG. Restore old
	functionallity.

Fri Jun 19 18:54:27 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-attribute-buffer):
	changed case of default value type, here and in many other functions.
	(sgml-translate-attribute-specification-list): changed case for
	declared value

	* psgml-parse.el (sgml-parse-attribute-specification-list):
	changed case of default value type

1998-06-16  Dave Love  <d.love@dl.ac.uk>

	* psgml-edit.el (sgml-read-element-name,
	sgml-read-attribute-value, sgml-insert-attribute,
	sgml-custom-markup): Use sgml-namecase-general to set
	completion-ignore-case.

1998-06-16  Dave Love  <d.love@dl.ac.uk>

	* psgml-parse.el (sgml-push-to-entity): Don't use save-excursion
	around insert-file-contents -- may break in Emacs 20.3.

Fri Jun 19 10:40:53 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-dtd.el (sgml-check-declared-value): upcase NOTATION

	* psgml-parse.el (sgml-read-element-name): bind
	completion-ignore-case as suggested by Mark Eichin. Also present
	element names in the insert case.

Tue Jun 16 00:31:03 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-command-post): added ignore-errors

	* psgml-parse.el (sgml-get-delim-string): new func.
	(sgml-delim): changed to macro.
	(sgml-do-usemap): upcase #EMPTY
	(sgml-parse-xml-comment): set markup type

	* psgml-dtd.el (sgml-validate-default-value-rn): upcase keywords
	(sgml-declare-entity): remove case fiddling

	* psgml-parse.el (sgml-check-case): remove case fiddling -- retain
	check.

	* psgml-dtd.el (sgml-validate-declared-value): upcase attribute types
	(sgml-check-default-value): remove case fiddling -- reserved names
	should be in upper case.

	* psgml-parse.el (sgml-push-to-entity): use syntax table from
	current buffer in entity buffer and not the sgml-parser-syntax as
	XML will use another syntax table.

Wed Jun 10 23:28:42 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-catalog-lookup): Take additional catalogs
	in right order.

Thu May 14 20:02:42 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* Version 1.1.1

	* psgml.el (psgml-version): new version 1.1.1

	* psgml-dtd.el (sgml-parse-character-reference): upcase funchar
	names.

	* psgml-edit.el (sgml-indent-line): compute indentation from
	context, not element under point. Removed special handling of
	start-tag and document context. Extra indentation if in markup.

	* psgml-parse.el (sgml-parse-external): use upper case keywords.
	(sgml-check-case): use upper case instead of lower case.

Wed May 13 06:13:05 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-do-marked-section): Change keyword strings
	to upper case.
	(sgml-general-case): Use Upcase instead of Downcase.
	(sgml-parse-markup-declaration): upcase keywords.

Sat Mar 14 21:31:09 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-do-processing-instruction): Added
	recognition of PSGML NOFILL.
	(sgml-parse-catalog-buffer): add catalog as a noname entry
	(sgml-catalog-lookup): handle catalog entries

Thu Mar 12 00:04:52 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-current-element-name): make buffer local

Wed Mar 11 22:11:01 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-insert-start-tag): extended meaning of NET
	paramenter to insert XML-TAGCE if XML.
	(sgml-change-start-tag): keep XML-TAGCE

	* psgml-parse.el (sgml-read-element-name): use completing read on
	all defined element types if in an ANY context.
	(sgml-check-tag-close): removed check for XML-TAGCE
	(sgml-do-start-tag): added check for XML-TAGCE
	(sgml-element-empty): In XML no special handling of elements with
	declared content of EMPTY, but use conref to signal empty element tag.

	* psgml-dtd.el (sgml-merge-attlists): reverse the list

Tue Mar 10 20:13:11 1998  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el: Merged David Megginson's latest xml modifications.

Sat Nov 15 20:50:35 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-parse-attribute-value-specification): New func.
	(sgml-parse-attribute-specification-list): use new func. This
	changes an error to a warning to make better error recovery when
	illegal characters occurs in starttag.

Sun Aug 17 20:22:28 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-cache-catalog): remove file-truename. This
	made relative filenames refer to the wrong directory if the
	catalog file was a symlink.

Thu Jul 24 22:36:15 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-modify-dtd): fixed bug in handling
	sgml-parent-document.

Mon May 19 18:43:32 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-edit.el (sgml-expand-entity-reference): changed to allow
	point to be within entity referens, not only at start of ref. As
	suggested by Matthias Clasen.
	(sgml-edit-external-entity): new command contributed by Matthias
	Clasen <clasen@netzservice.de>

	* psgml-charent.el (sgml-charent-to-display-char): fix bug in regexp.

Sat Mar 15 19:20:57 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml-parse.el (sgml-check-tag-close): change sgml-error to
 	sgml-log-warning

Sun Jan 12 19:15:32 1997  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (psgml-version): bump version

Fri Nov 22 20:29:44 1996  Lennart Staflin  <lenst@lysator.liu.se>

	* psgml.el (sgml-parse-colon-path): use path-separator if
	available.
